diff --git a/src/monitor.c b/src/monitor.c
index 7bc53d2c..161c5431 100644
--- a/src/monitor.c
+++ b/src/monitor.c
@@ -62,7 +62,7 @@ zend_bool pthreads_monitor_unlock(pthreads_monitor_t *m) {
 }
 
 pthreads_monitor_state_t pthreads_monitor_check(pthreads_monitor_t *m, pthreads_monitor_state_t state) {
-	return (m->state & state) == (state);
+	return (m->state & state);
 }
 
 int pthreads_monitor_wait(pthreads_monitor_t *m, long timeout) {
@@ -92,13 +92,8 @@ int pthreads_monitor_notify(pthreads_monitor_t *m) {
 }
 
 void pthreads_monitor_wait_until(pthreads_monitor_t *m, pthreads_monitor_state_t state) {
-	if (pthreads_monitor_lock(m)) {
-		while (!pthreads_monitor_check(m, state)) {
-			if (pthreads_monitor_wait(m, 0) != 0) {
-				break;
-			}
-		}
-		pthreads_monitor_unlock(m);
+	while (!pthreads_monitor_check(m, state)) {
+		pthreads_monitor_wait(m, 0);
 	}
 }
 
diff --git a/src/monitor.h b/src/monitor.h
index 17a58f2f..89d9bd9f 100644
--- a/src/monitor.h
+++ b/src/monitor.h
@@ -18,16 +18,16 @@
 #ifndef HAVE_PTHREADS_MONITOR_H
 #define HAVE_PTHREADS_MONITOR_H
 
-typedef volatile unsigned int pthreads_monitor_state_t;
+typedef unsigned long pthreads_monitor_state_t;
 
 typedef struct _pthreads_monitor_t pthreads_monitor_t;
 
-#define PTHREADS_MONITOR_NOTHING 0x000000
-#define PTHREADS_MONITOR_READY   0x000010
-#define PTHREADS_MONITOR_STARTED 0x000100
-#define PTHREADS_MONITOR_RUNNING 0x001000
-#define PTHREADS_MONITOR_JOINED  0x010000
-#define PTHREADS_MONITOR_ERROR	 0x100000
+#define PTHREADS_MONITOR_NOTHING (0)
+#define PTHREADS_MONITOR_READY   (1<<0)
+#define PTHREADS_MONITOR_STARTED (1<<1)
+#define PTHREADS_MONITOR_RUNNING (1<<2)
+#define PTHREADS_MONITOR_JOINED  (1<<3)
+#define PTHREADS_MONITOR_ERROR	 (1<<4)
 
 pthreads_monitor_t* pthreads_monitor_alloc();
 zend_bool pthreads_monitor_lock(pthreads_monitor_t *m);
diff --git a/src/object.c b/src/object.c
index 92e455df..da32b617 100644
--- a/src/object.c
+++ b/src/object.c
@@ -278,6 +278,8 @@ static void pthreads_base_ctor(pthreads_object_t* base, zend_class_entry *entry)
 /* {{{ */
 void pthreads_base_free(zend_object *object) {
 	pthreads_object_t* base = PTHREADS_FETCH_FROM(object);
+	
+	HANDLE_BLOCK_INTERRUPTIONS();
 
 	if (PTHREADS_IS_NOT_CONNECTION(base)) {
 		if ((PTHREADS_IS_THREAD(base)||PTHREADS_IS_WORKER(base)) &&
@@ -285,18 +287,22 @@ void pthreads_base_free(zend_object *object) {
 			pthreads_join(base);
 		}
 
-		pthreads_store_free(base->store);
-		
-		if (PTHREADS_IS_WORKER(base)) {
-		    pthreads_stack_free(base->stack);	
-		}
+		if (pthreads_monitor_lock(base->monitor)) {
+			pthreads_store_free(base->store);
 
-		pthreads_monitor_free(base->monitor);
+			if (PTHREADS_IS_WORKER(base)) {
+				pthreads_stack_free(base->stack);	
+			}
+
+			pthreads_monitor_free(base->monitor);	
+		}
 	}
 
 	zend_object_std_dtor(object);
 
 	pthreads_globals_object_delete(base);
+
+	HANDLE_UNBLOCK_INTERRUPTIONS();
 } /* }}} */
 
 /* {{{ */
diff --git a/src/prepare.c b/src/prepare.c
index df96ff44..c4b1f595 100644
--- a/src/prepare.c
+++ b/src/prepare.c
@@ -589,7 +589,11 @@ static inline void pthreads_kill_handler(int signo) /* {{{ */
 /* {{{ */
 int pthreads_prepared_startup(pthreads_object_t* thread) {
 #ifdef PTHREADS_KILL_SIGNAL
+#ifdef ZEND_SIGNAL
+	zend_signal(PTHREADS_KILL_SIGNAL, pthreads_kill_handler);
+#else
 	signal(PTHREADS_KILL_SIGNAL, pthreads_kill_handler);
+#endif
 #endif
 
 	thread->local.id = pthreads_self();
diff --git a/src/store.c b/src/store.c
index a43a2c1b..7dcd27e9 100644
--- a/src/store.c
+++ b/src/store.c
@@ -419,7 +419,7 @@ void pthreads_store_tohash(zval *object, HashTable *hash) {
 /* {{{ */
 void pthreads_store_free(pthreads_store_t *store){
 	zend_hash_destroy(&store->table);
-	free(store);	
+	free(store);
 } /* }}} */
 
 /* {{{ */
